<?php 
/* Child theme generated with WPS Child Theme Generator */
            
if ( ! function_exists( 'b7ectg_theme_enqueue_styles' ) ) {            
    add_action( 'wp_enqueue_scripts', 'b7ectg_theme_enqueue_styles' );
    
    function b7ectg_theme_enqueue_styles() {
        wp_enqueue_style( 'parent-style', get_template_directory_uri() . '/style.css' );
        wp_enqueue_style( 'child-style', get_stylesheet_directory_uri() . '/style.css', array( 'parent-style' ) );
    }
}

function enqueue_google_fonts() {
    // Replace 'Open+Sans:400,700' with the specific Google Fonts you want to use
    $google_fonts_url = 'https://fonts.googleapis.com/css2?family=Montserrat:ital,wght@0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&display=swap" rel="stylesheet';

    // Enqueue the Google Fonts stylesheet
    wp_enqueue_style( 'google-fonts', $google_fonts_url, array(), null );
}

// Hook the function to the 'wp_enqueue_scripts' action
add_action( 'wp_enqueue_scripts', 'enqueue_google_fonts' );




function create_custom_post_type_tours() {
    $labels = array(
        'name'               => _x( 'Tours', 'post type general name', 'your-text-domain' ),
        'singular_name'      => _x( 'Tour', 'post type singular name', 'your-text-domain' ),
        'menu_name'          => _x( 'Tours', 'admin menu', 'your-text-domain' ),
        'name_admin_bar'     => _x( 'Tour', 'add new on admin bar', 'your-text-domain' ),
        'add_new'            => _x( 'Add New', 'tour', 'your-text-domain' ),
        'add_new_item'       => __( 'Add New Tour', 'your-text-domain' ),
        'new_item'           => __( 'New Tour', 'your-text-domain' ),
        'edit_item'          => __( 'Edit Tour', 'your-text-domain' ),
        'view_item'          => __( 'View Tour', 'your-text-domain' ),
        'all_items'          => __( 'All Tours', 'your-text-domain' ),
        'search_items'       => __( 'Search Tours', 'your-text-domain' ),
        'parent_item_colon'  => __( 'Parent Tours:', 'your-text-domain' ),
        'not_found'          => __( 'No tours found.', 'your-text-domain' ),
        'not_found_in_trash' => __( 'No tours found in Trash.', 'your-text-domain' ),
    );

    $args = array(
        'labels'             => $labels,
        'description'        => __( 'Description of your custom post type', 'your-text-domain' ),
        'public'             => true,
        'publicly_queryable' => true,
        'show_ui'            => true,
        'show_in_menu'       => true,
        'query_var'          => true,
        'rewrite'            => array( 'slug' => 'tours' ),
        'capability_type'    => 'post',
        'has_archive'        => true,
        'hierarchical'       => false,
        'menu_position'      => null,
        'supports'           => array( 'title', 'editor', 'author', 'thumbnail', 'excerpt', 'comments' ),
    );

    register_post_type( 'tours', $args );


$taxonomy_labels = array(
        'name'                       => _x( 'Tour Destinations', 'taxonomy general name', 'your-text-domain' ),
        'singular_name'              => _x( 'Tour Category', 'taxonomy singular name', 'your-text-domain' ),
        'search_items'               => __( 'Search Tour Destinations', 'your-text-domain' ),
        'all_items'                  => __( 'All Tour Destinations', 'your-text-domain' ),
        'edit_item'                  => __( 'Edit Tour Destination', 'your-text-domain' ),
        'update_item'                => __( 'Update Tour Destination', 'your-text-domain' ),
        'add_new_item'               => __( 'Add New Tour Destination', 'your-text-domain' ),
        'new_item_name'              => __( 'New Tour Destination Name', 'your-text-domain' ),
        'menu_name'                  => __( 'Tour Destinations', 'your-text-domain' ),
        'popular_items'              => __( 'Popular Tour Destinations', 'your-text-domain' ),
        'separate_items_with_commas' => __( 'Separate tour Destinations with commas', 'your-text-domain' ),
        'add_or_remove_items'        => __( 'Add or remove tour destinations', 'your-text-domain' ),
        'choose_from_most_used'      => __( 'Choose from the most used tour destinations', 'your-text-domain' ),
        'not_found'                  => __( 'No tour destinations found', 'your-text-domain' ),
    );

    $taxonomy_args = array(
        'labels'            => $taxonomy_labels,
        'hierarchical'      => true,
        'public'            => true,
        'show_ui'           => true,
        'show_admin_column' => true,
        'query_var'         => true,
        'rewrite'           => array( 'slug' => 'tour-category' ),
    );

    register_taxonomy( 'tour_category', 'tours', $taxonomy_args );
}

add_action( 'init', 'create_custom_post_type_tours' );



// Add support for widgets
if (!function_exists('theme_widgets_init')) {
    function theme_widgets_init() {
        register_sidebar( array(
            'name'          => esc_html__( 'Sidebar Tours', 'your-theme-textdomain' ),
            'id'            => 'sidebar-tours',
            'description'   => esc_html__( 'Add widgets for services here.', 'your-theme-textdomain' ),
            'before_widget' => '<div id="%1$s" class="widget %2$s">',
            'after_widget'  => '</div>',
            'before_title'  => '<h2 class="widget-title">',
            'after_title'   => '</h2>',
        ) );

        register_sidebar( array(
            'name'          => esc_html__( 'Sidebar Tours Contact Us', 'your-theme-textdomain' ),
            'id'            => 'sidebar-contact-us',
            'description'   => esc_html__( 'Add widgets for contact information here.', 'your-theme-textdomain' ),
            'before_widget' => '<div id="%1$s" class="widget %2$s">',
            'after_widget'  => '</div>',
            'before_title'  => '<h2 class="widget-title">',
            'after_title'   => '</h2>',
        ) );
    }
    add_action( 'widgets_init', 'theme_widgets_init' );
}
