<?php 
/* Child theme generated with WPS Child Theme Generator */
            
if ( ! function_exists( 'b7ectg_theme_enqueue_styles' ) ) {            
    add_action( 'wp_enqueue_scripts', 'b7ectg_theme_enqueue_styles' );
    
    function b7ectg_theme_enqueue_styles() {
        wp_enqueue_style( 'parent-style', get_template_directory_uri() . '/style.css' );
        wp_enqueue_style( 'child-style', get_stylesheet_directory_uri() . '/style.css', array( 'parent-style' ) );
    }
}

function enqueue_google_fonts() {
    // Replace 'Open+Sans:400,700' with the specific Google Fonts you want to use
    $google_fonts_url = 'https://fonts.googleapis.com/css2?family=Montserrat:ital,wght@0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&display=swap" rel="stylesheet';

    // Enqueue the Google Fonts stylesheet
    wp_enqueue_style( 'google-fonts', $google_fonts_url, array(), null );
}

// Hook the function to the 'wp_enqueue_scripts' action
add_action( 'wp_enqueue_scripts', 'enqueue_google_fonts' );




function create_custom_post_type_tours() {
    $labels = array(
        'name'               => _x( 'Tours', 'post type general name', 'your-text-domain' ),
        'singular_name'      => _x( 'Tour', 'post type singular name', 'your-text-domain' ),
        'menu_name'          => _x( 'Tours', 'admin menu', 'your-text-domain' ),
        'name_admin_bar'     => _x( 'Tour', 'add new on admin bar', 'your-text-domain' ),
        'add_new'            => _x( 'Add New', 'tour', 'your-text-domain' ),
        'add_new_item'       => __( 'Add New Tour', 'your-text-domain' ),
        'new_item'           => __( 'New Tour', 'your-text-domain' ),
        'edit_item'          => __( 'Edit Tour', 'your-text-domain' ),
        'view_item'          => __( 'View Tour', 'your-text-domain' ),
        'all_items'          => __( 'All Tours', 'your-text-domain' ),
        'search_items'       => __( 'Search Tours', 'your-text-domain' ),
        'parent_item_colon'  => __( 'Parent Tours:', 'your-text-domain' ),
        'not_found'          => __( 'No tours found.', 'your-text-domain' ),
        'not_found_in_trash' => __( 'No tours found in Trash.', 'your-text-domain' ),
    );

    $args = array(
        'labels'             => $labels,
        'description'        => __( 'Description of your custom post type', 'your-text-domain' ),
        'public'             => true,
        'publicly_queryable' => true,
        'show_ui'            => true,
        'show_in_menu'       => true,
        'query_var'          => true,
        'rewrite'            => array( 'slug' => 'tours' ),
        'capability_type'    => 'post',
        'has_archive'        => true,
        'hierarchical'       => false,
        'menu_position'      => null,
        'supports'           => array( 'title', 'editor', 'author', 'thumbnail', 'excerpt', 'comments' ),
    );

    register_post_type( 'tours', $args );


$taxonomy_labels = array(
        'name'                       => _x( 'Tour Destinations', 'taxonomy general name', 'your-text-domain' ),
        'singular_name'              => _x( 'Tour Category', 'taxonomy singular name', 'your-text-domain' ),
        'search_items'               => __( 'Search Tour Destinations', 'your-text-domain' ),
        'all_items'                  => __( 'All Tour Destinations', 'your-text-domain' ),
        'edit_item'                  => __( 'Edit Tour Destination', 'your-text-domain' ),
        'update_item'                => __( 'Update Tour Destination', 'your-text-domain' ),
        'add_new_item'               => __( 'Add New Tour Destination', 'your-text-domain' ),
        'new_item_name'              => __( 'New Tour Destination Name', 'your-text-domain' ),
        'menu_name'                  => __( 'Tour Destinations', 'your-text-domain' ),
        'popular_items'              => __( 'Popular Tour Destinations', 'your-text-domain' ),
        'separate_items_with_commas' => __( 'Separate tour Destinations with commas', 'your-text-domain' ),
        'add_or_remove_items'        => __( 'Add or remove tour destinations', 'your-text-domain' ),
        'choose_from_most_used'      => __( 'Choose from the most used tour destinations', 'your-text-domain' ),
        'not_found'                  => __( 'No tour destinations found', 'your-text-domain' ),
    );

    $taxonomy_args = array(
        'labels'            => $taxonomy_labels,
        'hierarchical'      => true,
        'public'            => true,
        'show_ui'           => true,
        'show_admin_column' => true,
        'query_var'         => true,
        'rewrite'           => array( 'slug' => 'tour-category' ),
    );

    register_taxonomy( 'tour_category', 'tours', $taxonomy_args );
}

add_action( 'init', 'create_custom_post_type_tours' );

// New Taxonomy Called Interests
function custom_taxonomy_for_tours() {
    $labels = array(
        'name'                       => _x( 'Interests', 'taxonomy general name' ),
        'singular_name'              => _x( 'Interest', 'taxonomy singular name' ),
        'search_items'               => __( 'Search Interests' ),
        'all_items'                  => __( 'All Interests' ),
        'parent_item'                => __( 'Parent Interest' ),
        'parent_item_colon'          => __( 'Parent Interest:' ),
        'edit_item'                  => __( 'Edit Interest' ),
        'update_item'                => __( 'Update Interest' ),
        'add_new_item'               => __( 'Add New Interest' ),
        'new_item_name'              => __( 'New Interest Name' ),
        'menu_name'                  => __( 'Interests' ),
        'view_item'                  => __( 'View Interest' ),
        'popular_items'              => __( 'Popular Interests' ),
        'separate_items_with_commas' => __( 'Separate interests with commas' ),
        'add_or_remove_items'        => __( 'Add or remove interests' ),
        'choose_from_most_used'      => __( 'Choose from the most used interests' ),
        'not_found'                  => __( 'No interests found' ),
        'back_to_items'              => __( 'Back to interests' ),
    );

    $args = array(
        'labels'                     => $labels,
        'hierarchical'               => true,
        'public'                     => false,
        'show_ui'                    => true,
        'show_admin_column'          => true,
        'show_in_nav_menus'          => true,
        'show_tagcloud'              => false,
        'rewrite'                    => false,
        'capabilities'               => array(
            'manage_terms' => 'edit_pages', // Allows editors to manage terms
            'edit_terms'   => 'edit_pages',
            'delete_terms' => 'edit_pages',
            'assign_terms' => 'edit_pages',
        ),
    );

    register_taxonomy( 'interests', array( 'tours' ), $args );
}
add_action( 'init', 'custom_taxonomy_for_tours' );

 





// Add support for widgets
if (!function_exists('theme_widgets_init')) {
    function theme_widgets_init() {
        register_sidebar( array(
            'name'          => esc_html__( 'Sidebar Tours', 'your-theme-textdomain' ),
            'id'            => 'sidebar-tours',
            'description'   => esc_html__( 'Add widgets for services here.', 'your-theme-textdomain' ),
            'before_widget' => '<div id="%1$s" class="widget %2$s">',
            'after_widget'  => '</div>',
            'before_title'  => '<h2 class="widget-title">',
            'after_title'   => '</h2>',
        ) );
        
        
           register_sidebar( array(
            'name'          => esc_html__( 'Uganda Tours', 'your-theme-textdomain' ),
            'id'            => 'uganda-tours',
            'description'   => esc_html__( 'Add widgets for services here.', 'your-theme-textdomain' ),
            'before_widget' => '<div id="%1$s" class="widget %2$s">',
            'after_widget'  => '</div>',
            'before_title'  => '<h2 class="widget-title">',
            'after_title'   => '</h2>',
        ) );
		
		  
           register_sidebar( array(
            'name'          => esc_html__( 'RWanda Tours', 'your-theme-textdomain' ),
            'id'            => 'rwanda-tours',
            'description'   => esc_html__( 'Add widgets for services here.', 'your-theme-textdomain' ),
            'before_widget' => '<div id="%1$s" class="widget %2$s">',
            'after_widget'  => '</div>',
            'before_title'  => '<h2 class="widget-title">',
            'after_title'   => '</h2>',
        ) );
        

   register_sidebar( array(
            'name'          => esc_html__( 'Kenya Tours', 'your-theme-textdomain' ),
            'id'            => 'kenya-tours',
            'description'   => esc_html__( 'Add widgets for services here.', 'your-theme-textdomain' ),
            'before_widget' => '<div id="%1$s" class="widget %2$s">',
            'after_widget'  => '</div>',
            'before_title'  => '<h2 class="widget-title">',
            'after_title'   => '</h2>',
        ) );



   register_sidebar( array(
            'name'          => esc_html__( 'Tanzania Tours', 'your-theme-textdomain' ),
            'id'            => 'tanzania-tours',
            'description'   => esc_html__( 'Add widgets for services here.', 'your-theme-textdomain' ),
            'before_widget' => '<div id="%1$s" class="widget %2$s">',
            'after_widget'  => '</div>',
            'before_title'  => '<h2 class="widget-title">',
            'after_title'   => '</h2>',
        ) );

   register_sidebar( array(
            'name'          => esc_html__( 'Congo Tours', 'your-theme-textdomain' ),
            'id'            => 'congo-tours',
            'description'   => esc_html__( 'Add widgets for services here.', 'your-theme-textdomain' ),
            'before_widget' => '<div id="%1$s" class="widget %2$s">',
            'after_widget'  => '</div>',
            'before_title'  => '<h2 class="widget-title">',
            'after_title'   => '</h2>',
        ) );
        
        
        

        register_sidebar( array(
            'name'          => esc_html__( 'Sidebar Tours Contact Us', 'your-theme-textdomain' ),
            'id'            => 'sidebar-contact-us',
            'description'   => esc_html__( 'Add widgets for contact information here.', 'your-theme-textdomain' ),
            'before_widget' => '<div id="%1$s" class="widget %2$s">',
            'after_widget'  => '</div>',
            'before_title'  => '<h2 class="widget-title">',
            'after_title'   => '</h2>',
        ) );
    }
    add_action( 'widgets_init', 'theme_widgets_init' );
}



function footer_tours_shortcode() {
    $args = array(
        'post_type'      => 'tours', // Assuming 'tour' is the custom post type
        'tax_query'      => array(
            array(
               'post_type'      => 'tours',
        'posts_per_page' => -1, // Display all posts
            ),
        ),
        'posts_per_page' => 12,
    );

$default_image_url = 'https://rwandagorillatours.com/wp-content/uploads/2024/03/New-Project-6-2.png';
    $query = new WP_Query( $args );
    ?>
    <div class="tour-wrapper footer-slider">
    <?php
    if ( $query->have_posts() ) {
        while ( $query->have_posts() ) {
            $query->the_post();
            ?>
		<div class="tour-content-outer">
           <div class="tour-item" style="background-image: url('<?php echo has_post_thumbnail() ? get_the_post_thumbnail_url( get_the_ID(), 'full' ) : $default_image_url; ?>')">
				<div class="errrrr">
					
				</div>
                </div>
				<div class="tour-content">
                    <h3><?php the_title(); ?></h3>
                    <div class="mkjiop"><?php the_excerpt(); ?></div>
                    <a href="<?php the_permalink(); ?>" class="read-more">Read more</a>
                
            </div></div>
            <?php
        }
        wp_reset_postdata();
    } else {
        ?>
        <p>No tours found.</p>
        <?php
    }
    ?>
    </div> <!-- Close tour-wrapper div -->
    <?php
}
add_shortcode( 'footer_tours', 'footer_tours_shortcode' );



function rwanda_tours_shortcode() {
    $args = array(
        'post_type'      => 'tours', // Assuming 'tour' is the custom post type
        'tax_query'      => array(
            array(
                'taxonomy' => 'tour_category',
                'field'    => 'slug',
                'terms'    => 'rwanda_gorillas', // Term slug for Rwanda
            ),
        ),
        'posts_per_page' => 12,
    );

$default_image_url = 'https://rwandagorillatours.com/wp-content/uploads/2024/03/New-Project-6-2.png';
    $query = new WP_Query( $args );
    ?>
    <div class="tour-wrapper">
    <?php
    if ( $query->have_posts() ) {
        while ( $query->have_posts() ) {
            $query->the_post();
            ?>
		<div class="tour-content-outer">
<div class="tour-item" style="background-image: url('<?php echo has_post_thumbnail() ? get_the_post_thumbnail_url( get_the_ID(), 'full' ) : $default_image_url; ?>')">
				<div class="errrrr">
					
				</div>
                </div>
				<div class="tour-content">
                    <h3><?php the_title(); ?></h3>
                    <div class="mkjiop"><?php the_excerpt(); ?></div>
                    <a href="<?php the_permalink(); ?>" class="read-more">Read more</a>
                
            </div></div>
            <?php
        }
        wp_reset_postdata();
    } else {
        ?>
        <p>No tours found.</p>
        <?php
    }
    ?>
    </div> <!-- Close tour-wrapper div -->
    <?php
}
add_shortcode( 'rwanda_tours', 'rwanda_tours_shortcode' );




//Uganda Safaris

function uganda_tours_shortcode() {
    $args = array(
        'post_type'      => 'tours', // Assuming 'tour' is the custom post type
        'tax_query'      => array(
            array(
                'taxonomy' => 'tour_category',
                'field'    => 'slug',
                'terms'    => 'uganda_tours', // Term slug for Rwanda
            ),
        ),
        'posts_per_page' => 12,
    );
	
	
$default_image_url = 'https://rwandagorillatours.com/wp-content/uploads/2024/03/New-Project-6-2.png';

    $query = new WP_Query( $args );
    ?>
    <div class="tour-wrapper">
    <?php
    if ( $query->have_posts() ) {
        while ( $query->have_posts() ) {
            $query->the_post();
            ?>
		<div class="tour-content-outer">
          <div class="tour-item" style="background-image: url('<?php echo has_post_thumbnail() ? get_the_post_thumbnail_url( get_the_ID(), 'full' ) : $default_image_url; ?>')">
				<div class="errrrr">
					
				</div>
                </div>
				<div class="tour-content">
                    <h3><?php the_title(); ?></h3>
                    <div class="mkjiop"><?php the_excerpt(); ?></div>
                    <a href="<?php the_permalink(); ?>" class="read-more">Read more</a>
                
            </div></div>
            <?php
        }
        wp_reset_postdata();
    } else {
        ?>
        <p>No tours found.</p>
        <?php
    }
    ?>
    </div> <!-- Close tour-wrapper div -->
    <?php
}
add_shortcode( 'uganda_tours', 'uganda_tours_shortcode' );


// Tanzania Tours

function tanzania_tours_shortcode() {
    $args = array(
        'post_type'      => 'tours', // Assuming 'tour' is the custom post type
        'tax_query'      => array(
            array(
                'taxonomy' => 'tour_category',
                'field'    => 'slug',
                'terms'    => 'tanzania_tours', // Term slug for Rwanda
            ),
        ),
        'posts_per_page' => 12,
    );

$default_image_url = 'https://rwandagorillatours.com/wp-content/uploads/2024/03/New-Project-6-2.png';
    $query = new WP_Query( $args );
    ?>
    <div class="tour-wrapper">
    <?php
    if ( $query->have_posts() ) {
        while ( $query->have_posts() ) {
            $query->the_post();
            ?>
		<div class="tour-content-outer">
            <div class="tour-item" style="background-image: url('<?php echo has_post_thumbnail() ? get_the_post_thumbnail_url( get_the_ID(), 'full' ) : $default_image_url; ?>')">
				<div class="errrrr">
					
				</div>
                </div>
				<div class="tour-content">
                    <h3><?php the_title(); ?></h3>
                    <div class="mkjiop"><?php the_excerpt(); ?></div>
                    <a href="<?php the_permalink(); ?>" class="read-more">Read more</a>
                
            </div></div>
            <?php
        }
        wp_reset_postdata();
    } else {
        ?>
        <p>No tours found.</p>
        <?php
    }
    ?>
    </div> <!-- Close tour-wrapper div -->
    <?php
}
add_shortcode( 'tanzania_tours', 'tanzania_tours_shortcode' );


// Kenya Tours

function kenya_tours_shortcode() {
    $args = array(
        'post_type'      => 'tours', // Assuming 'tour' is the custom post type
        'tax_query'      => array(
            array(
                'taxonomy' => 'tour_category',
                'field'    => 'slug',
                'terms'    => 'kenya_tours', // Term slug for Rwanda
            ),
        ),
        'posts_per_page' => 12,
    );

$default_image_url = 'https://rwandagorillatours.com/wp-content/uploads/2024/03/New-Project-6-2.png';
    $query = new WP_Query( $args );
    ?>
    <div class="tour-wrapper">
    <?php
    if ( $query->have_posts() ) {
        while ( $query->have_posts() ) {
            $query->the_post();
            ?>
		<div class="tour-content-outer">
           <div class="tour-item" style="background-image: url('<?php echo has_post_thumbnail() ? get_the_post_thumbnail_url( get_the_ID(), 'full' ) : $default_image_url; ?>')">
				<div class="errrrr">
					
				</div>
                </div>
				<div class="tour-content">
                    <h3><?php the_title(); ?></h3>
                    <div class="mkjiop"><?php the_excerpt(); ?></div>
                    <a href="<?php the_permalink(); ?>" class="read-more">Read more</a>
                
            </div></div>
            <?php
        }
        wp_reset_postdata();
    } else {
        ?>
        <p>No tours found.</p>
        <?php
    }
    ?>
    </div> <!-- Close tour-wrapper div -->
    <?php
}
add_shortcode( 'kenya_tours', 'kenya_tours_shortcode' );

// Kenya Tours

function congo_tours_shortcode() {
    $args = array(
        'post_type'      => 'tours', // Assuming 'tour' is the custom post type
        'tax_query'      => array(
            array(
                'taxonomy' => 'tour_category',
                'field'    => 'slug',
                'terms'    => 'congo_tours', // Term slug for Rwanda
            ),
        ),
        'posts_per_page' => 12,
    );

$default_image_url = 'https://rwandagorillatours.com/wp-content/uploads/2024/03/New-Project-6-2.png';
    $query = new WP_Query( $args );
    ?>
    <div class="tour-wrapper">
    <?php
    if ( $query->have_posts() ) {
        while ( $query->have_posts() ) {
            $query->the_post();
            ?>
		<div class="tour-content-outer">
    <div class="tour-item" style="background-image: url('<?php echo has_post_thumbnail() ? get_the_post_thumbnail_url( get_the_ID(), 'full' ) : $default_image_url; ?>')">
				<div class="errrrr">
					
				</div>
                </div>
				<div class="tour-content">
                    <h3><?php the_title(); ?></h3>
                    <div class="mkjiop"><?php the_excerpt(); ?></div>
                    <a href="<?php the_permalink(); ?>" class="read-more">Read more</a>
                
            </div></div>
            <?php
        }
        wp_reset_postdata();
    } else {
        ?>
        <p>No tours found.</p>
        <?php
    }
    ?>
    </div> <!-- Close tour-wrapper div -->
    <?php
}
add_shortcode( 'congo_tours', 'congo_tours_shortcode' );









function enqueue_slick_slider() {
    wp_enqueue_style('slick-css', 'https://cdn.jsdelivr.net/npm/slick-carousel@1.8.1/slick/slick.css');
    wp_enqueue_style('slick-theme-css', 'https://cdn.jsdelivr.net/npm/slick-carousel@1.8.1/slick/slick-theme.css');
    wp_enqueue_script('slick-js', 'https://cdn.jsdelivr.net/npm/slick-carousel@1.8.1/slick/slick.min.js', array('jquery'), null, true);
}
add_action('wp_enqueue_scripts', 'enqueue_slick_slider');
